'
' PBVLTEST.BAS, example program for Virtual list control, PBVLIST.INC
' Shows how to create, modify colors and work with the control, etc.
'
#COMPILE EXE
#INCLUDE "WIN32API.INC" 'PB's win API declares include file
#INCLUDE "PBVLIST.INC"  'virtual listbox include file
'--------------------------------------------------------------------
%IDC_BUTN1  = 101
%IDC_BUTN2  = 102
%IDC_BUTN3  = 103
%IDC_BUTN4  = 104
%IDC_BUTN5  = 105
%IDC_BUTN6  = 106
%IDC_LABEL1 = 110
%IDC_VLIST1 = 121
%IDC_VLIST2 = 122
'--------------------------------------------------------------------
GLOBAL A()     AS STRING   ' Arrays must be global
GLOBAL info()  AS STRING
GLOBAL hVList1 AS DWORD, hVList2 AS DWORD
'--------------------------------------------------------------------
DECLARE CALLBACK FUNCTION DlgCallback()

'
' PBMAIN - load and show a dialog
'
FUNCTION PBMAIN() AS LONG
  LOCAL hDlg AS DWORD

  DIALOG NEW 0, "PBVList32 Example test",,, 208, 196, %WS_SYSMENU TO hDlg

  CONTROL ADD LABEL,  hDlg, %IDC_LABEL1, "",              4,   4,  120,   9
  CONTROL ADD BUTTON, hDlg, %IDC_BUTN1, "Create array", 130,  14,   70,  14
  CONTROL ADD BUTTON, hDlg, %IDC_BUTN2, "Show array",   130,  28,   70,  14
  CONTROL ADD BUTTON, hDlg, %IDC_BUTN3, "Add item",     130,  46,   70,  14
  CONTROL ADD BUTTON, hDlg, %IDC_BUTN4, "Insert item",  130,  60,   70,  14
  CONTROL ADD BUTTON, hDlg, %IDC_BUTN5, "Change item",  130,  74,   70,  14
  CONTROL ADD BUTTON, hDlg, %IDC_BUTN6, "Delete item",  130,  88,   70,  14
  CONTROL ADD BUTTON, hDlg, %IDCANCEL, "Exit",          130, 107,   70,  14

  hVList1 = CreateVirtualList(hDlg, %IDC_VLIST1, 4, 14, 120, 107, %TRUE)
  hVList2 = CreateVirtualList(hDlg, %IDC_VLIST2, 4, 126, 196, 51, %TRUE)

  'Create and set an information array for second listbox (hVList2)
  REDIM info(4) AS STRING
  info(0) = " VIRTUAL LISTBOX CONTROL"
  info(1) = " For viewing unlimited sized arrays in a very fast way."
  info(2) = " Manual in PBVLIST.INC, sample code in PBVLIST.BAS"
  info(3) = ""
  info(4) = " Public Domain by Borje Hagsten, December 2000"

  SendMessage hVList2, %VLB_SETARRAY, VARPTR(info(0)), UBOUND(info)
  SendMessage hVList2, %VLB_REFRESH, 0, 0

  'Disable some buttons
  CONTROL DISABLE hDlg, %IDC_BUTN2
  CONTROL DISABLE hDlg, %IDC_BUTN4
  CONTROL DISABLE hDlg, %IDC_BUTN5
  CONTROL DISABLE hDlg, %IDC_BUTN6

  DIALOG SHOW MODAL hDlg CALL DlgCallback

END FUNCTION

'
' Dialog procedure
'
CALLBACK FUNCTION DlgCallback()
  LOCAL I AS LONG, tl AS LONG

  SELECT CASE CBMSG
     CASE %WM_CTLCOLORLISTBOX 'give info listbox other colors
        IF CBLPARAM = hVList2 THEN
           SetTextColor CBWPARAM, RGB(128,0,0)
           SetBkMode    CBWPARAM, %TRANSPARENT
           FUNCTION = GetSysColorBrush(%COLOR_INFOBK)
        END IF

     CASE %WM_COMMAND
        SELECT CASE CBCTL
           CASE %IDC_BUTN1  ' Create array
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 MOUSEPTR 11
                 REDIM A(65534)
                 FOR I = 0 TO UBOUND(A) : A(I) = "Line number " & FORMAT$(I) : NEXT
                 MOUSEPTR 0
                 CONTROL ENABLE CBHNDL, %IDC_BUTN2
              END IF

           CASE %IDC_BUTN2  ' Show array - instant action
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 SendMessage hVList1, %VLB_SETARRAY, VARPTR(A(0)), UBOUND(A)
                 SendMessage hVList1, %VLB_REFRESH, 0, 0
                 SetFocus hVList1
              END IF

           CASE %IDC_BUTN3 ' Add item to end of array
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 REDIM PRESERVE A(UBOUND(A) + 1)
                 A(UBOUND(A)) = "Added at line" & STR$(UBOUND(A))
                 SendMessage hVList1, %VLB_SETARRAY, VARPTR(A(0)), UBOUND(A)
                 SendMessage hVList1, %VLB_SETTOPLINE, UBOUND(A), %FALSE
                 SendMessage hVList1, %VLB_REFRESH, 0, 0
              END IF

           CASE %IDC_BUTN4  ' Insert new item right before selected item
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 tl = SendMessage(hVList1, %VLB_GETTOPLINE, 0, 0)
                 I = SendMessage(hVList1, %VLB_GETSELECTED, 0, 0)
                 IF I > -1 THEN
                    REDIM PRESERVE A(UBOUND(A) + 1)
                    ARRAY INSERT A(I), "Inserted at line" & STR$(I)
                    SendMessage hVList1, %VLB_SETARRAY, VARPTR(A(0)), UBOUND(A)

                    SendMessage hVList1, %VLB_SETTOPLINE, tl, %FALSE
                    SendMessage hVList1, %VLB_SETSELECTED, I, %FALSE
                    SendMessage hVList1, %VLB_REFRESH, 0, 0
                 END IF
                 SetFocus hVList1
              END IF

           CASE %IDC_BUTN5  ' Change selected item
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 I = SendMessage(hVList1, %VLB_GETSELECTED, 0, 0)
                 IF I > -1 THEN
                    A(I) = A(I) + " - changed"
                    SendMessage hVList1, %VLB_REFRESH, 0, 0
                    SetFocus hVList1
                 END IF
              END IF

           CASE %IDC_BUTN6  ' Delete selected item
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 tl = SendMessage(hVList1, %VLB_GETTOPLINE, 0, 0)
                 I  = SendMessage(hVList1, %VLB_GETSELECTED, 0, 0)
                 IF I > -1 THEN
                    ARRAY DELETE A(I)
                    IF UBOUND(A) THEN
                       REDIM PRESERVE A(UBOUND(A) - 1)
                    ELSE
                       ERASE A
                       CONTROL DISABLE CBHNDL, %IDC_BUTN4
                       CONTROL DISABLE CBHNDL, %IDC_BUTN5
                       CONTROL DISABLE CBHNDL, %IDC_BUTN6
                    END IF
                    SendMessage hVList1, %VLB_SETARRAY, VARPTR(A(0)), UBOUND(A)

                    SendMessage hVList1, %VLB_SETTOPLINE, tl, %FALSE
                    SendMessage hVList1, %VLB_SETSELECTED, I, %FALSE
                    SendMessage hVList1, %VLB_REFRESH, 0, 0
                 END IF
                 SetFocus hVList1
              END IF

           CASE %IDCANCEL 
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN DIALOG END CBHNDL

           CASE %IDC_VLIST1 ' Virtual ListBox notification messages
              SELECT CASE CBCTLMSG
                 CASE %VLBN_RETURN
                    I = SendMessage(hVList1, %VLB_GETSELECTED, 0, 0)
                    IF I > -1 THEN
                       MessageBox CBHNDL, "Enter key pressed on : " & A(I) & CHR$(0), _
                                          "PBVList32 Example test" & CHR$(0), %MB_OK
                       SetFocus hVList1
                    END IF

                 CASE %VLBN_SPACE
                    I = SendMessage(hVList1, %VLB_GETSELECTED, 0, 0)
                    IF I > -1 THEN
                       MessageBox CBHNDL, "Space bar pressed on : " & A(I) & CHR$(0), _
                                          "PBVList32 Example test" & CHR$(0), %MB_OK
                       SetFocus hVList1
                    END IF

                 CASE %VLBN_DELETE
                    I = SendMessage(hVList1, %VLB_GETSELECTED, 0, 0)
                    IF I > -1 THEN
                       ' To save ourselves some work, trigger the Delete button's code.
                       SendMessage CBHNDL, %WM_COMMAND, MAKLNG(%IDC_BUTN6, %BM_CLICK), _
                                                        GetDlgItem(CBHNDL, %IDC_BUTN6)
                       SetFocus hVList1
                    END IF

                 CASE %LBN_DBLCLK
                    I = SendMessage(hVList1, %VLB_GETSELECTED, 0, 0)
                    MessageBox CBHNDL, "Double-clicked on : " & A(I) & CHR$(0), _
                                       "PBVList32 Example test" & CHR$(0), %MB_OK
                    SetFocus hVList1

                 CASE %LBN_KILLFOCUS
                 CASE %LBN_SETFOCUS
                 CASE %LBN_SELCHANGE
                    I = SendMessage(hVList1, %VLB_GETSELECTED, 0, 0)
                    IF I > -1 THEN
                       CONTROL SET TEXT CBHNDL, %IDC_LABEL1, "Text:  " + A(I)
                       IF IsWindowEnabled(GetDlgItem(CBHNDL, %IDC_BUTN4)) = 0 THEN
                          CONTROL ENABLE CBHNDL, %IDC_BUTN4
                          CONTROL ENABLE CBHNDL, %IDC_BUTN5
                          CONTROL ENABLE CBHNDL, %IDC_BUTN6
                       END IF
                    END IF

           END SELECT
        END SELECT
  END SELECT

END FUNCTION
