'
' PBVLTST2.BAS, example program for Virtual list control, PBVLIST.INC
' Shows how to use Virtual listbox for fast switching between arrays.
'
#COMPILE EXE
#INCLUDE "WIN32API.INC"
#INCLUDE "PBVLIST.INC"

GLOBAL A()     AS STRING   ' Arrays must be global
GLOBAL B()     AS STRING
GLOBAL C()     AS STRING
GLOBAL hVList1 AS DWORD

DECLARE CALLBACK FUNCTION DlgCallback()

'
' PBMAIN - load and show a dialog
'
FUNCTION PBMAIN() AS LONG
  LOCAL hDlg AS DWORD, I AS LONG

  DIALOG NEW %NULL, "PBVList32 multiple arrays test",,, 208, 106, %WS_SYSMENU TO hDlg

  CONTROL ADD OPTION, hDlg, 20, "Show array A", 130,   4,   60,  12, %WS_GROUP
  CONTROL ADD OPTION, hDlg, 21, "Show array B", 130,  16,   60,  12, %WS_CHILD
  CONTROL ADD OPTION, hDlg, 22, "Show array C", 130,  28,   60,  12, %WS_CHILD
  CONTROL ADD BUTTON, hDlg, %IDCANCEL,  "Exit", 130,  73,   70,  14

  hVList1 = CreateVirtualList(hDlg, 100,          4,   4,  120,  80, %TRUE)

  REDIM A(500), B(500), C(500) 'Create 3 global arrays
  FOR I = 0 TO UBOUND(A)
     A(I) = "List A, line number"  & STR$(I)
     B(I) = "List B, item number:" & STR$(I)
     C(I) = "List C, row number:"  & STR$(I)
  NEXT

  CONTROL SET CHECK hDlg, 20, %TRUE                  'Check first Option control
  SendMessage hVList1, %VLB_SETARRAY, VARPTR(A(0)), UBOUND(A) 'Set Array to show
  SendMessage hVList1, %VLB_REFRESH, 0, 0

  DIALOG SHOW MODAL hDlg CALL DlgCallback

END FUNCTION

'
' Callback for main dialog
'
CALLBACK FUNCTION DlgCallback()
  SELECT CASE CBMSG
     CASE %WM_COMMAND
        SELECT CASE CBCTL
           CASE 20  ' Show array A - instant action
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 SendMessage hVList1, %VLB_SETARRAY, VARPTR(A(0)), UBOUND(A)
                 SendMessage hVList1, %VLB_REFRESH, 0, 0
              END IF

           CASE 21  ' Show array B - instant action
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 SendMessage hVList1, %VLB_SETARRAY, VARPTR(B(0)), UBOUND(B)
                 SendMessage hVList1, %VLB_REFRESH, 0, 0
              END IF

           CASE 22  ' Show array C - instant action
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 SendMessage hVList1, %VLB_SETARRAY, VARPTR(C(0)), UBOUND(C)
                 SendMessage hVList1, %VLB_REFRESH, 0, 0
              END IF

           CASE %IDCANCEL
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN DIALOG END CBHNDL

           CASE 100 ' Virtual ListBox messages and notifications
              SELECT CASE CBCTLMSG
                 CASE %VLBN_RETURN
                 CASE %VLBN_SPACE
                 CASE %VLBN_DELETE
                 CASE %LBN_DBLCLK
                 CASE %LBN_KILLFOCUS
                 CASE %LBN_SETFOCUS
                 CASE %LBN_SELCHANGE
           END SELECT
        END SELECT
  END SELECT

END FUNCTION
